#include <WinFile.mqh>  
//-----------------------------------------------------------------------------------------------
//Funcionalidad para LeerArchivo (WinApi)
#define OF_READ               0
#import "kernel32.dll"
   int _lopen  (string path, int of);   
   int _llseek (int handle, int offset, int origin);
   int _lread  (int handle, string buffer, int bytes);   
   int _lclose (int handle);
#import

extern int     fxTime = PERIOD_H1;
extern string  folder = "C:\\XTB\\ARB\\DEMO\\R_data\\historicos\\";
extern string  fileType = ".csv";                                       
string   activos[84] = {
                           // FOREX #25
                         "AUDCAD.","AUDCHF.","AUDJPY.","AUDNZD.","AUDUSD.", //5
                         "CADCHF.","CADJPY.","CHFJPY.", //3
                         "EURAUD.","EURCAD.","EURCHF.","EURGBP.","EURJPY.","EURNZD.","EURUSD.", //7
                         "GBPAUD.","GBPCHF.","GBPJPY.","GBPNZD.","GBPUSD.", //5
                         "NZDUSD.","NZDJPY.", //2
                         "USDCAD.","USDCHF.","USDJPY.", //3
                           // INDEX #13
                         "DE.30.","EU.50.","UK.100.","FRA.40.","SPA.35.","ITA.40.","US.30.","US.100.","US.500.","US2000.", //10
                         "BUND10Y.","TNOTE.","SCHATZ2Y.", //3
                           // INDEX RARE #13
                         "AUS200.","BRAComp.","CZKCASH.","EMISS.","HUNComp.","INDIA50.","JAP225.","KOSP200.","MEXComp.","SUI20.","RUS50.","VOLX.","W.20.", //13
                           // PRECIOUS METALS #3
                         "GOLDs.","SILVERs.","PLATINUM.", //3
                           // ENEGETIC #3
                         "OILs.","OIL.WTI.","NATGAS.", //3
                           // COMMODITIES METALS #4
                         "ALUMINIUM.","COPPER.","NICKEL.","ZINC.", //4
                           // COMMODITIES AGRICULTURE #6
                         "COFFEE.","CORN.","COTTONs.","SOYBEAN.","SUGARs.","WHEAT.", //6
                         // FOREX RARE 17#
                         "CHFHUF.","CHFPLN.", //2
                         "EURCZK.","EURHUF.","EURNOK.","EURPLN.","EURRON.","EURSEK.","EURTRY.", //7
                         "GBPPLN.", //1
                         "USDCZK.","USDHUF.","USDNOK.","USDPLN.","USDRON.","USDSEK.","USDTRY." //7
                       };
int start(){
   string fileLoc, strTime, activo, strPrice;
   string strOpen, strHigh, strLow, strClose;
   datetime barTime;
   int minute;   
   string dd,MM,YYYY,hh,convertedTime;         
   int fWrite, b;
   int n = ArraySize(activos);
   bool flag,fus;

   for(int i = 0; i < n; i++){
      activo = activos[i];    
      WindowHandle(activo,60);
      fileLoc = StringConcatenate(folder,activo,"60",fileType);
      fWrite = OpenNewFileForWriting(fileLoc);                   
      if ( MarketInfo(activo, MODE_BID) > 0 ){               
         for ( b = iBars(activo, fxTime) - 1; b >= 0; b-- ){  
            barTime = iTime(activo, fxTime, b);    
            dd      = ""+TimeDay(barTime)     ;if   (StringLen(dd)  ==1 ){dd  ="0"+dd;  }
            MM      = ""+TimeMonth(barTime)   ;if   (StringLen(MM)  ==1 ){MM  ="0"+MM;  }
            YYYY    = ""+TimeYear(barTime)    ;while(StringLen(YYYY)<4  ){YYYY="0"+YYYY;}
            hh      = ""+TimeHour(barTime)    ;if   (StringLen(hh)  ==1 ){hh  ="0"+hh;  }
            minute  = TimeMinute(barTime);            
            if(minute>30){                              
               hh   = (TimeHour(barTime)+1)+"";if   (StringLen(hh)  ==1 ){hh  ="0"+hh;  }
               if (hh=="23"){hh="00";}
            }            
            convertedTime = YYYY +"-"+ MM +"-"+ dd +" "+ hh +":"+"00:00";
            strOpen = DoubleToStr(iOpen(activo, fxTime, b), MarketInfo(activo, MODE_DIGITS));
            strHigh = DoubleToStr(iHigh(activo, fxTime, b), MarketInfo(activo, MODE_DIGITS));
            strLow = DoubleToStr(iLow(activo, fxTime, b), MarketInfo(activo, MODE_DIGITS));
            strClose = DoubleToStr(iClose(activo, fxTime, b), MarketInfo(activo, MODE_DIGITS));            
            strPrice = StringConcatenate(convertedTime,",",strOpen,",",strHigh,",",strLow,",",strClose); 
            WriteToFile(fWrite, StringConcatenate(strPrice, "\r\n"));                                                      
         }
         Print("Last data stored for " + activo + " is: " + strPrice);       
      }else{
         Print(" ******************* --> ACTIVO" + activo + " is not available.");         
      }
      CloseFile(fWrite);                                 
   }
   return(0);
}

